﻿using System;
using System.Management;
using System.Threading;

namespace CSharpWatchProcessor
{
    class Program
    {
        void Go()
        {
            ManagementClass proc =
                new ManagementClass("Win32_Processor");
            ManagementClass batt =
                new ManagementClass("Win32_Battery");

            while (true)
            {
                ManagementObjectCollection cpus =
                    proc.GetInstances();
                foreach (ManagementObject cpu in cpus)
                {
                    Console.WriteLine("Processeur");
                    UInt32 maxclockspeed = (UInt32)cpu.GetPropertyValue("MaxClockSpeed");
                    UInt32 currentclockspeed = (UInt32)cpu.GetPropertyValue("CurrentClockSpeed");
                    Console.WriteLine("CurrentClockSpeed: {0} Max: {1}", currentclockspeed, maxclockspeed);
                    try
                    {
                        UInt32 voltagecaps = (UInt32)cpu.GetPropertyValue("VoltageCaps");
                        Console.WriteLine("VoltageCaps: {0}", voltagecaps);
                    }
                    catch (SystemException)
                    {
                        Console.WriteLine("VoltageCaps inconnu");
                    }

                    UInt16 currentvoltage = (UInt16)cpu.GetPropertyValue("CurrentVoltage");
                    Console.WriteLine("CurrentVoltage: {0}V", currentvoltage / 10.0);
                }
                Console.WriteLine();
                Console.WriteLine("Batterie");
                ManagementObjectCollection batteries = batt.GetInstances();
                foreach (ManagementObject batterie in batteries)
                {
                    UInt16 status = (UInt16)batterie.GetPropertyValue("BatteryStatus");
                    Console.WriteLine("Status: " + BatterieStatus(status));
                    UInt16 charge_percent = (UInt16)batterie.GetPropertyValue("EstimatedChargeRemaining");
                    Console.WriteLine("Charge: {0} %", charge_percent);
                    if (status != 2) // si alimentation secteur, pas de problème d'autonomie :-)
                    {
                        UInt32 autonomie = (UInt32)batterie.GetPropertyValue("EstimatedRunTime");
                        Console.WriteLine("Autonomie estimee: {0} minutes", autonomie);
                    }
                }

                Console.WriteLine();
                Console.WriteLine();
                Thread.Sleep(3000);
            }
        }
        static void Main(string[] args)
        {
            Program p = new Program();
            p.Go();
        }

        String BatterieStatus(UInt16 status)
        {
            String s;
            switch (status)
            {
                case 1:
                    s = "en decharge";
                    break;
                case 2:
                    s = "alimentation secteur";
                    break;
                case 3:
                    s = "pleine charge";
                    break;
                case 4:
                    s = "faible";
                    break;
                case 5:
                    s = "critique";
                    break;
                case 6:
                    s = "en charge";
                    break;
                case 7:
                    s = "en charge et haute";
                    break;
                case 8:
                    s = "en charge et faible";
                    break;
                case 9:
                    s = "en charge et critique";
                    break;
                case 10:
                    s = "indefini";
                    break;
                case 11:
                    s = "charge partielle";
                    break;
                default:
                    s = "inconnu";
                    break;
            }
            return s;
        }
    }
}
