// CppWatchProcessor.cpp 

#include <iostream>
using namespace std;

#include <windows.h>
#include <PowrProf.h>

typedef struct _PROCESSOR_POWER_INFORMATION
{
	ULONG Number; 
	ULONG MaxMhz;
	ULONG CurrentMhz;
	ULONG MhzLimit;
	ULONG MaxIdleState;
	ULONG CurrentIdleState;
} PROCESSOR_POWER_INFORMATION,  *PPROCESSOR_POWER_INFORMATION;

int main(int argc, char* argv[])
{
	SYSTEM_POWER_POLICY spp;
	PROCESSOR_POWER_INFORMATION *ppi;
	SYSTEM_BATTERY_STATE sbs;
	SYSTEM_INFO si;

	
	while(true)
	{

		
		CallNtPowerInformation(SystemPowerPolicyAc,
		NULL,
		0,
		&spp,
		sizeof(SYSTEM_POWER_POLICY));

		
		cout << "Current throttle: " << (int)spp.DynamicThrottle << endl;
		cout << "Forced throttle: " << (int)spp.ForcedThrottle << endl;
		cout << "Min throttle: " << (int)spp.MinThrottle << endl;


		GetSystemInfo(&si);
		ppi = new PROCESSOR_POWER_INFORMATION[si.dwNumberOfProcessors];
		CallNtPowerInformation(ProcessorInformation,
			NULL,
			0,
			ppi,
			sizeof(PROCESSOR_POWER_INFORMATION)*si.dwNumberOfProcessors);

		for(DWORD i=0; i<si.dwNumberOfProcessors;i++)
		{
			cout << "Processeur " << i << endl;
			cout << "Frequence maxi: " << ppi[i].MaxMhz << endl;
			cout << "Frequence actuelle: " << ppi[i].CurrentMhz << endl;
		}
		delete[] ppi;
		cout << endl;

		CallNtPowerInformation(SystemBatteryState,
			NULL,
			0,
			&sbs,
			sizeof(SYSTEM_BATTERY_STATE));

		if(sbs.AcOnLine)
			cout << "Alimentation secteur" << endl;
		if(sbs.BatteryPresent)
			cout << "Une batterie est presente sur le systeme" << endl;
		if(sbs.Charging)
			cout << "Batterie en charge" << endl;
		if(sbs.Discharging)
		{
			cout << "Batterie en decharge" << endl;
			cout << "Autonomie estimee: " << sbs.EstimatedTime/60 << " minutes" << endl;
		}
		cout << endl;
		Sleep(3000);
	}
	return 0;
}
