// DemoPowerEnumerate.cpp 

#include <iostream>
using namespace std;

#include <windows.h>
#include <PowrProf.h>

#define BIGSIZE 1024
DWORD bigsize = BIGSIZE;

void ConvertString(WCHAR* src, CHAR* dest)
{
	BOOL UsedDefault;

	WideCharToMultiByte(CP_OEMCP,
		WC_NO_BEST_FIT_CHARS,
		src,
		-1,
		dest,
		BIGSIZE,
		" ",
		&UsedDefault);
}

void PrintGuid(GUID* guid)
{
	cout << hex;
	cout << guid->Data1 << "-" << guid->Data2 << "-" << guid->Data3;
	for(int i=0;i<8;i++)
		cout << (int)guid->Data4[i];
	cout << endl;
}


void PrintPowerScheme(GUID* guid)
{
	DWORD result;
	UCHAR buffer[BIGSIZE];
	CHAR chBuffer[BIGSIZE];

	result = PowerReadDescription(NULL,
		guid,
		NULL,
		NULL,
		buffer,
		&bigsize);

	if(!result)
	{
		ConvertString((WCHAR*)buffer, chBuffer);
		cout << chBuffer << endl;
	}
	bigsize = BIGSIZE;

	result = PowerReadFriendlyName(NULL,
		guid,
		NULL,
		NULL,
		buffer,
		&bigsize);

	if(!result)
	{
		ConvertString((WCHAR*)buffer, chBuffer);
		cout << chBuffer << endl;
	}
	bigsize = BIGSIZE;
}

int main(int argc, char* argv[])
{
	UCHAR* buffer;
	DWORD buffersize;
	ULONG index;
	DWORD result;

	index = 0;
	result = 0;
	while(1)
	{
		result = PowerEnumerate(NULL,
			NULL, //Scheme GUID
			NULL, // SubGroup GUID
			ACCESS_SCHEME,
			index,
			NULL, // demander la taille du buffer
			&buffersize);
		if(result != 0 && result != ERROR_MORE_DATA)
			break;

		buffer = (UCHAR *)LocalAlloc(LPTR, buffersize);
		result = PowerEnumerate(NULL,
			NULL, //Scheme GUID
			NULL, // SubGroup GUID
			ACCESS_SCHEME,
			index,
			buffer, 
			&buffersize);
		if(result)
		{
			LocalFree(buffer);
			break;
		}
		
		PrintGuid((GUID*)buffer);
		PrintPowerScheme((GUID*)buffer);
		cout << endl;
		LocalFree(buffer);
		index++;
	}

	return 0;
}

