// DemoReadProcessorPowerSettings.cpp : D


#include <iostream>
using namespace std;

#include <windows.h>
#include <PowrProf.h>
#include <initguid.h> // pour le DEFINE_GUID ci-dessous

// {370F4BE5-D0FE-4128-9854-DE54765376CA}
DEFINE_GUID(PROGRAMMEZGUID, 
0x370f4be5, 0xd0fe, 0x4128, 0x98, 0x54, 0xde, 0x54, 0x76, 0x53, 0x76, 0xca);

//DEFINE_GUID(PROGRAMMEZGUID,
//0x381b4222, 0xf694, 0x41f0, 0x9685, 0xff, 0x5b, 0xb2, 0x60, 0xdf, 0x2e);

#define BIGSIZE 1024
DWORD bigsize = BIGSIZE;

void ConvertString(WCHAR* src, CHAR* dest)
{
	BOOL UsedDefault;

	WideCharToMultiByte(CP_OEMCP,
		WC_NO_BEST_FIT_CHARS,
		src,
		-1,
		dest,
		BIGSIZE,
		" ",
		&UsedDefault);
}

void PrintGuid(GUID* guid)
{
	cout << hex;
	cout << guid->Data1 << "-" << guid->Data2 << "-" << guid->Data3;
	for(int i=0;i<8;i++)
		cout << (int)guid->Data4[i];
	cout << endl;
}


void PrintPowerSetting(GUID* leguid, GUID* sous_guid, GUID* setting)
{
	DWORD result;
	UCHAR buffer[BIGSIZE];
	CHAR chBuffer[BIGSIZE];
	ULONG letype;

	result = PowerReadDescription(NULL,
		leguid,
		sous_guid,
		setting,
		buffer,
		&bigsize);

	if(!result)
	{
		ConvertString((WCHAR*)buffer, chBuffer);
		cout << chBuffer << endl;
	}
	bigsize = BIGSIZE;

	result = PowerReadFriendlyName(NULL,
		leguid,
		sous_guid,
		setting,
		buffer,
		&bigsize);

	if(!result)
	{
		ConvertString((WCHAR*)buffer, chBuffer);
		cout << chBuffer << endl;
	}
	bigsize = BIGSIZE;

	result = PowerReadACValue(NULL,
		leguid,
		sous_guid,
		setting,
		&letype,
		buffer,
		&bigsize);

	cout << dec;
	switch(letype)
	{
	case REG_DWORD:
		cout << "Valeur entiere: " << (int)(*buffer) << endl;
		break;
	case REG_SZ:
		cout << "Valeur chaine: " << buffer << endl;
		break;
	default:
		cout << "Type non reconnu" << endl;
		break;
	}

	bigsize = BIGSIZE;
}

int main(int argc, char* argv[])
{
	UCHAR* buffer;
	DWORD buffersize;
	ULONG index;
	DWORD result;

	GUID leguid = PROGRAMMEZGUID;
	GUID sous_guid = GUID_PROCESSOR_SETTINGS_SUBGROUP;


	index = 0;
	result = 0;
	while(1)
	{
		result = PowerEnumerate(NULL,
			&leguid, //Scheme GUID
			&sous_guid, // SubGroup GUID
			ACCESS_INDIVIDUAL_SETTING,
			index,
			NULL, // demander la taille du buffer
			&buffersize);
		if(result != 0 && result != ERROR_MORE_DATA)
			break;

		buffer = (UCHAR *)LocalAlloc(LPTR, buffersize);
		result = PowerEnumerate(NULL,
			&leguid, //Scheme GUID
			&sous_guid, // SubGroup GUID
			ACCESS_INDIVIDUAL_SETTING,
			index,
			buffer, 
			&buffersize);
		if(result)
		{
			LocalFree(buffer);
			break;
		}
		
		PrintGuid((GUID*)buffer);
		PrintPowerSetting(&leguid, &sous_guid, (GUID*)buffer);
		cout << endl;
		LocalFree(buffer);
		index++;
	}

	
	return 0;
}

